--[[
Copyright (C) 2016-2017  Neemys

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

See <LICENSE.txt> for a copy of this license, or see <http://www.gnu.org/licenses/>
]]

if(not buildingplatform.config.disableOwnPlatform) then
	--initialize var depending on the generation choosen by the user
	local autoplaceObject,needAutoplace

	if(settings.startup[buildingplatform.constants.platformGeneratorSetting].value == "concentric-circle" or settings.startup[buildingplatform.constants.platformGeneratorSetting].value == "grid") then
		autoplaceObject = nil
		needAutoplace = false
	else

		needAutoplace = true
		autoplaceObject	= {
			control = buildingplatform.constants.tileName,
			sharpness = 0.4,
			coverage = 0.07,
			starting_area_size = 20,
			peaks = {
				-- control generation outside starting area, less frequent but bigger than starting area.
				{
					noise_layer = buildingplatform.constants.tileName,
					noise_octaves_difference = -1.5,
					noise_persistence = 0.3,
					starting_area_weight_optimal = 0,
					starting_area_weight_range = 0,
					starting_area_weight_max_range = 2,
				},
				-- control generation inside starting area.
				{
				  influence = 0.3,
				  starting_area_weight_optimal = 1,
				  starting_area_weight_range = 0,
				  starting_area_weight_max_range = 2,
				},
				{
				  influence = 0.75,
				  noise_layer = buildingplatform.constants.tileName,
				  noise_octaves_difference = -2.4,
				  noise_persistence = 0.2,
				  starting_area_weight_optimal = 1,
				  starting_area_weight_range = 0,
				  starting_area_weight_max_range = 2,
				},
				-- as tile can cover water, we need to block spawn below 0 elevation.
				{
					influence = 1e4, -- big number to be sure it have priority
					-- as max elevation is 5000 we could have wrote 2500 in each, but devs used 5000, there must be a reason....
					elevation_optimal = 5000,
					elevation_range = 5000,
					elevation_max_range = 5000,
				},
			},
		}
	end
	local tilefunction = function(tile) end
	local oldOrNew = settings.startup[buildingplatform.constants.oldTextureSetting].value and "building-platform-old" or "building-platform"
	local picturesDirectory = buildingplatform.constants.modRoot.."/graphics/"..oldOrNew
	local tileColor = {
		r = (127),
		g = (127),
		b = (127)
	}
	local aliases = nil
	--If factorissimo2 detected and the config has been set, add aliases to the platform
	if(buildingplatform.detectedMods.factorissimo2 and settings.startup[buildingplatform.constants.factorissimo2FactoryAsPlatformSetting].value) then
		aliases = {"factory-floor-1","factory-pattern-1","factory-floor-2","factory-pattern-2","factory-floor-3","factory-pattern-3"}
	end

	local platformObject = buildingplatform.addPlatform(buildingplatform.constants.tileName,needAutoplace,"c-a" ,autoplaceObject,picturesDirectory,tileColor,tilefunction,aliases)
	buildingplatform.addTileToDefaultInitialization(platformObject)
end
